﻿Imports Leap

Public Class LeapListener
    Inherits Listener

    Public Overrides Sub OnConnect(ctlr As Controller)
        'ctlr.Config.SetFloat("Gesture.Swipe.MinLength", 10)
        'ctlr.Config.SetFloat("Gesture.Swipe.MinVelocity", 100)
        'ctlr.Config.Save()
        ctlr.EnableGesture(Gesture.GestureType.TYPEKEYTAP)
    End Sub

    Public Overrides Sub OnFrame(ctlr As Controller)
        Dim currentFrame As Frame = ctlr.Frame
        If (Not currentFrame.Hands.IsEmpty) Then

            Dim firstHand As Hand = currentFrame.Hands(0)
            Dim fingers As FingerList = firstHand.Fingers

            If (Not fingers.IsEmpty) Then
                Dim gestures As GestureList = currentFrame.Gestures
                For Each gst As Gesture In gestures
                    If gst.Type = Gesture.GestureType.TYPEKEYTAP Then
                        TapAction(fingers, TapDirection.Tap)
                    End If
                    Next      
            End If
        End If
    End Sub

    Public Delegate Sub TapEvent(ByVal sd As TapDirection)
    Public Event LeapTap As TapEvent

    Private fingersCount As Integer

    Private Sub TapAction(ByVal fingers As FingerList, ByVal sd As TapDirection)
        fingersCount = fingers.Count
        If (fingersCount = 1) Then
            Select Case sd
                Case TapDirection.Tap
                    RaiseEvent LeapTap(TapDirection.Tap)
            End Select
        End If
    End Sub
End Class


