﻿Imports Leap
Imports System.Windows.Ink
Imports System.Windows.Media.Animation

Class MainWindow
    Private leap As New Controller
    Private touchIndicator As New DrawingAttributes
    Private touchPoint As StylusPoint

    Private windowWidth As Double = 525
    Private windowHeight As Double = 350
    Private x As Integer
    Private y As Integer
    Private tx As Double
    Private ty As Double

    Private FingersCount As Integer

    Private Sub MainWindow_Loaded(sender As Object, e As RoutedEventArgs) Handles Me.Loaded
        AddHandler CompositionTarget.Rendering, AddressOf Update
        touchIndicator.Width = 10
        touchIndicator.Height = 10
        touchIndicator.StylusTip = StylusTip.Ellipse
    End Sub

    Private Sub Update(sender As Object, e As EventArgs)
        strb = TryCast(Me.Resources("Storyboard1"), Storyboard)
        paintCanvas.Strokes.Clear()
        windowWidth = Me.Width
        windowHeight = Me.Height

        Dim frame As Leap.Frame = leap.Frame
        Dim interactionBox As InteractionBox = leap.Frame.InteractionBox

        For Each Pointable As Pointable In leap.Frame.Pointables
            Dim normalizedPosition As Leap.Vector = interactionBox.NormalizePoint(Pointable.StabilizedTipPosition)

            tx = normalizedPosition.x * windowWidth
            ty = windowHeight - normalizedPosition.y * windowHeight

            touchPoint = New StylusPoint(tx, ty)

            Dim tips As New StylusPointCollection(New StylusPoint() {touchPoint})
            Dim touchStroke As New Stroke(tips, touchIndicator)
            paintCanvas.Strokes.Add(touchStroke)

            'ホーバー
            If Pointable.TouchDistance > 0 AndAlso Pointable.TouchZone <> Global.Leap.Pointable.Zone.ZONENONE Then
                touchIndicator.Color = Colors.Navy
                x = touchPoint.X
                y = touchPoint.Y
                Index = 0
                FingersCount = leap.Frame.Fingers.Count

            ElseIf Pointable.TouchDistance <= 0 Then
                touchIndicator.Color = Colors.Red
                If FingersCount = 1 Then
                    If x > head.GetValue(Canvas.LeftProperty) And x < head.GetValue(Canvas.LeftProperty) + head.Width AndAlso y > head.GetValue(Canvas.TopProperty) And y < head.GetValue(Canvas.TopProperty) + head.Height Then
                        Index = 1
                    Else
                        Index = 0
                        strb.Stop()
                    End If
                End If

            Else
                touchIndicator.Color = Colors.Gold
                Index = 0
                strb.Stop()
            End If
        Next
    End Sub
End Class




